# Class DefaultColorSelectionModel

java.lang.Object
javax.swing.colorchooser.DefaultColorSelectionModel

All Implemented Interfaces:
  `Serializable, ColorSelectionModel`

public class DefaultColorSelectionModel extends Object implements ColorSelectionModel, Serializable
A generic implementation of `ColorSelectionModel`.

See Also:
  - `Color`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected ChangeEvent`
  `changeEvent`
  Only one `ChangeEvent` is needed per model instance since the event's only (read-only) state is the source property.
  `protected EventListenerList`
  `listenerList`
  The listener list.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultColorSelectionModel()`
  Creates a `DefaultColorSelectionModel` with the current color set to `Color.white`.
  `DefaultColorSelectionModel(Color color)`
  Creates a `DefaultColorSelectionModel` with the current color set to `color`, which should be non-`null`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addChangeListener(ChangeListener l)`
  Adds a `ChangeListener` to the model.
  `protected void`
  `fireStateChanged()`
  Runs each `ChangeListener`'s `stateChanged` method.
  `ChangeListener[]`
  `getChangeListeners()`
  Returns an array of all the `ChangeListener`s added to this `DefaultColorSelectionModel` with `addChangeListener`.
  `Color`
  `getSelectedColor()`
  Returns the selected `Color` which should be non-`null`.
  `void`
  `removeChangeListener(ChangeListener l)`
  Removes a `ChangeListener` from the model.
  `void`
  `setSelectedColor(Color color)`
  Sets the selected color to `color`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### changeEvent

    protected transient ChangeEvent changeEvent
    Only one `ChangeEvent` is needed per model instance since the event's only (read-only) state is the source property. The source of events generated here is always "this".

  - ### listenerList

    protected EventListenerList listenerList
    The listener list.

- ## Constructor Details

  - ### DefaultColorSelectionModel

    public DefaultColorSelectionModel()
    Creates a `DefaultColorSelectionModel` with the current color set to `Color.white`. This is the default constructor.

  - ### DefaultColorSelectionModel

    public DefaultColorSelectionModel(Color color)
    Creates a `DefaultColorSelectionModel` with the current color set to `color`, which should be non-`null`. Note that setting the color to `null` is undefined and may have unpredictable results.
    Parameters:
      `color` - the new `Color`

- ## Method Details

  - ### getSelectedColor

    public Color getSelectedColor()
    Returns the selected `Color` which should be non-`null`.
    Specified by:
      `getSelectedColor` in interface `ColorSelectionModel`
    Returns:
      the selected `Color`
    See Also:
      - `ColorSelectionModel.setSelectedColor(Color)`

  - ### setSelectedColor

    public void setSelectedColor(Color color)
    Sets the selected color to `color`. Note that setting the color to `null` is undefined and may have unpredictable results. This method fires a state changed event if it sets the current color to a new non-`null` color; if the new color is the same as the current color, no event is fired.
    Specified by:
      `setSelectedColor` in interface `ColorSelectionModel`
    Parameters:
      `color` - the new `Color`
    See Also:
      - `ColorSelectionModel.getSelectedColor()`
      - `ColorSelectionModel.addChangeListener(ChangeListener)`

  - ### addChangeListener

    public void addChangeListener(ChangeListener l)
    Adds a `ChangeListener` to the model.
    Specified by:
      `addChangeListener` in interface `ColorSelectionModel`
    Parameters:
      `l` - the `ChangeListener` to be added

  - ### removeChangeListener

    public void removeChangeListener(ChangeListener l)
    Removes a `ChangeListener` from the model.
    Specified by:
      `removeChangeListener` in interface `ColorSelectionModel`
    Parameters:
      `l` - the `ChangeListener` to be removed

  - ### getChangeListeners

    public ChangeListener[] getChangeListeners()
    Returns an array of all the `ChangeListener`s added to this `DefaultColorSelectionModel` with `addChangeListener`.
    Returns:
      all of the `ChangeListener`s added, or an empty array if no listeners have been added
    Since:
      1.4

  - ### fireStateChanged

    protected void fireStateChanged()
    Runs each `ChangeListener`'s `stateChanged` method.
    See Also:
      - `EventListenerList`